--- rc.hotplug.orig	2007-07-10 01:58:29.000000000 +0200
+++ rc.hotplug	2007-07-10 02:02:42.000000000 +0200
@@ -13,6 +13,13 @@
 
 PATH=/sbin:/bin:/usr/sbin:/usr/bin
 
+# If we are running a new version of udev (no /sbin/udevsend) on a 2.6+
+# kernel, then we can skip this script:
+if [ -x /etc/rc.d/rc.udev -a ! -x /sbin/udevsend -a ! "$(uname -r | cut -f 1,2 -d .)" = "2.4" ]; then
+  /bin/true
+else
+
+
 # Put a mark in the system logs as we enter this script:
 if [ -f /var/run/syslogd.pid -a -x /usr/bin/logger ]; then
        echo "/etc/rc.d/rc.hotplug $1 (entering script)" | logger
@@ -31,6 +38,14 @@
 	do
 	    $RC $1
 	done
+        # For kernels newer than 2.4, tell the kernel to use for /sbin/udevsend for
+        # hotplug events, and then run udevstart one more time.
+        if [ -x /etc/rc.d/rc.udev -a -x /sbin/udevsend -a ! "$(uname -r | cut -f 1,2 -d .)" = "2.4" ]; then
+    	  echo "/sbin/udevsend" > /proc/sys/kernel/hotplug
+          if [ -x /sbin/udevstart ]; then
+	    /sbin/udevstart
+	  fi
+        fi
 	touch /var/lock/subsys/hotplug
 	;;
     stop)
@@ -63,3 +78,4 @@
        echo "/etc/rc.d/rc.hotplug $1 (exiting script)" | logger
 fi
 
+fi
